
#  Copyright (C) 2003 Joe Mallon <jmmallon at joescafe dot com>
#  Reads data from iTunesDB & generates list of songs on iPod
#  URL: http://www.joescafe.com/tunes2html
#
#  Uses code from tunes2pod.pl in GNUPod
#  Copyright (C) 2002-2003 Adrian Ulrich <pab at blinkenlights.ch>
#  Part of the gnupod-tools collection
#
#  URL: http://www.gnu.org/software/gnupod/
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details:
#           http://www.gnu.org/licenses/gpl.txt
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# This script has been tested on Windows 98, Windows 2000 Professional, Mac OS X,
# Solaris 5.7, and Solaris 5.8.
#
# This script has been tested using Perl 5.005 and Perl 6.
#
# iTunes and iPod are trademarks of Apple
#
# This product is not supported/written/published by Apple!

#use strict;

# header of a valid iTunesDB
my $ipodmagic = "6d 68 62 64 68 00 00 00";
$| = "1";
$ver = "1.1";

print "tunes2html $ver (C) 2003 Joe Mallon\n";
print "This tool reads data from an iTunesDB file & generates a\n";
print "list of songs on the iPod\n";
print "Uses code from tunes2pod.pl 0.6 (C) 2002-2003 Adrian Ulrich\n";
print "This tool is covered by the GNU General Public License\n\n";

my %artists = my %playlists = my %collection = ();

#start the parser
print "Collecting song data:\n";
my ($infoptr,$playlist,$tracks,$sec,$size) = parsomatic();
%collection = %$infoptr;
%playlists = %$playlist;

print "Creating web page and text file:\n";

my($al, $allen, $alstr, $alstrx, $altr, $arlen, $arstrx, $arstr, $art, $artr, $cd, $cds, $count, $sets, $snum, $ti, $time, $tr, $var, $yr, @sin, @songs, @var);

foreach $al (sort byart (keys(%collection))) {
	$art = $collection{$al}->{'artist'};
	$alcomp = $al;
	$alcomp =~ s/(\W)/\\$1/g;
	push(@{$artists{$art}->{'albums'}},$al) unless (grep(/^$alcomp$/,@{$artists{$art}->{'albums'}}));
}

$sets = keys(%artists);
$cds = keys(%collection);
$size = sprintf("%.01f MB",$size/(1024*1024)) . " - " . sprintf("%.01f GB",$size/(1024*1024*1024));
$ti = int($sec / 86400) . "d ";
$sec = $sec % 86400;
$ti .= int($sec / 3600) . "h ";
$sec = $sec % 3600;
$ti .= int($sec/60) . "m " . $sec % 60 . "s";
my ($s,$m,$h,$d,$o,$y) = (localtime)[0,1,2,3,4,5];
$time = ($y + 1900) . "/" . sprintf("%02d",$o + 1) . "/" . sprintf("%02d",$d) . "  " . sprintf("%02d",$h) . ":" . sprintf("%02d",$m) . ":" . sprintf("%02d",$s);

open(OUTHTML, ">iPod.htm") or die "Could not write to iPod.htm: $!\n";
open(OUTTXT, ">iPod.txt") or die "Could not write to iPod.txt: $!\n";

print OUTTXT << "ENDOUTTXT";
iPod Contents - $time

Statistics
Sets: $sets
Discs: $cds
Tracks: $tracks
Playing Time: $ti
Space Used: $size

SINGLE ARTISTS

ENDOUTTXT

print OUTHTML << "ENDOUTHTML";
<HTML><HEAD><TITLE>iPod Contents</TITLE>
<style>
H4{margin-bottom:5px;color:lightgrey}
IMG{margin-right:3px;margin-left:10px;margin-top 1px}
LI{font-size:10pt;color:#000070;margin:1px}
OL{margin-top:0px;margin-bottom:0px}
TD{FONT-FAMILY:Tahoma;FONT-SIZE:9pt;}
BODY{margin:0px;BACKGROUND-COLOR:white;COLOR:black;FONT-FAMILY:Tahoma;FONT-SIZE:8pt}
.tdMain1{border:1px solid tan;background:ivory}
.tdMain2{border:1px solid tan;background:white}
.tdStatHdr{font-weight:bold;color:red}
.bHdr{border-bottom:1px solid tan}
.bBlueHdrSet{font-size:10pt;color:#000070;text-decoration: none;cursor:hand}
.bBlueHdrSet:hover{font-size:10pt;color:"red";text-decoration: none;cursor:hand}
.bGreenHdrSet{font-size:10pt;color:#007000;text-decoration: none;cursor:hand}
.bGreenHdrSet:hover{font-size:10pt;color:"red";text-decoration: none;cursor:hand}
.bGreenHdrAlbum{font-size:10pt;text-decoration: none;color:#007000;cursor:hand;position:relative;left:+15}
.bGreenHdrAlbum:hover{font-size:10pt;text-decoration: none;color:"red";cursor:hand}
.subImage{position:relative; left:+15px}
</style>

<SCRIPT LANGUAGE="JavaScript">
var plusImg = new Image();
	plusImg.src = "plusbl.gif"
var minusImg = new Image();
	minusImg.src = "minusbl.gif"

function showAlbums() {
	if (document.getElementsByTagName)
		x = document.getElementsByTagName('div');
	else if (document.all)
		x = document.all.tags('div');
	for (var i=0;i<x.length;i++)
	{
		if (x[i].id.indexOf("Set") != -1) {
			x[i].style.display = "";
		}
	}
	if (document.getElementsByTagName)
		x = document.getElementsByTagName('img');
	else if (document.all)
		x = document.all.tags('img');
	for (var i=0;i<x.length;i++)
	{
		if (x[i].id.indexOf("Set") != -1) {
			x[i].src = minusImg.src;
		}
	}
}

function hideAlbums() {
	if (document.getElementsByTagName)
		x = document.getElementsByTagName('div');
	else if (document.all)
		x = document.all.tags('div');
	for (var i=0;i<x.length;i++)
	{
		if ((x[i].id.indexOf("Set") != -1) || (x[i].id.indexOf("Album") != -1)) {
			x[i].style.display = "none";
		}
	}
	if (document.getElementsByTagName)
		x = document.getElementsByTagName('img');
	else if (document.all)
		x = document.all.tags('img');
	for (var i=0;i<x.length;i++)
	{
		if ((x[i].id.indexOf("Set") != -1) || (x[i].id.indexOf("Album") != -1)) {
			x[i].src = plusImg.src;
		}
	}
}

function showLevel( _levelId, _imgId ) {
	var thisLevel = document.getElementById( _levelId );
	var thisImg = document.getElementById( _imgId );
	if ( thisLevel.style.display == "none") {
		thisLevel.style.display = "";
		thisImg.src = minusImg.src;
		}
	else {
		thisLevel.style.display = "none";
		thisImg.src = plusImg.src;
		}
}
</SCRIPT>
</HEAD><BODY>
<div id=dvMain align=center>
<table style="border-bottom:1px solid tan" cellspacing=0 cellpadding=5 width="100%">
<tr bgcolor=ivory><td valign=middle><h2 style="margin-bottom:5px">iPod Contents</h2></td><td align=right valign=middle><h4 style="margin-bottom:5px;color:lightgrey">$time</h4></td></tr>
</table>
<table cellspacing=5 cellpadding=5 width="100%">
<tr><td valign=top class=tdMain2><b class=bHdr>Statistics</b><br><br>
<div id=dvStat style="margin-left:20px">
<table cellspacing=0 cellpadding=2>
<tr><td class=tdStatHdr>Sets:</td><td>$sets</td></tr>
<tr><td class=tdStatHdr>Discs:</td><td>$cds</td></tr>
<tr><td class=tdStatHdr>Tracks:</td><td>$tracks</td></tr>
<tr><td class=tdStatHdr>Playing Time:</td><td>$ti</td></tr>
<tr><td class=tdStatHdr>Space Used:</td><td>$size</td></tr>
</table>
</div>
</td></tr>
<tr><td valign=top class=tdMain1>
<a class=bBlueHdrSet href="javascript:showAlbums();"><b>Show All Albums</b></a><br>
<a class=bBlueHdrSet href="javascript:hideAlbums();"><b>Hide All Albums</b></a><p>
<b class=bHdr>Single Artists</b><p>

ENDOUTHTML

foreach $art (sort(keys(%artists))) {
	if ($art =~ /Various/) {
		push(@var,$art); 
	} else {
		push(@sin,$art); 
	}
}

my @arts = sort bythe (@sin);
push(@arts,@var);
foreach $art (@arts) {
	if (!$var and $art =~ /:Various/) {
		$var++;
		print OUTTXT "VARIOUS ARTISTS\n\n";
		print OUTHTML "<p><b class=bHdr>Various Artists</b><p>\n";
	}
	$arstr = $arstrx = "";
	$cd = @{$artists{$art}->{'albums'}};
	$artr = $arlen = 0;
	foreach $al (sort byyear(@{$artists{$art}->{'albums'}})) {
		$count++;
		$alstrx = $alstr = "";
		$altr = $allen = $snum = 0;
		if ($collection{$al}->{'sort'} eq 'track') {
			shift(@{$collection{$al}->{'tracks'}});
			@songs = @{$collection{$al}->{'tracks'}};
		} else {
			@songs = sort bysong (@{$collection{$al}->{'tracks'}});
		}
		foreach $tr (@songs) {
			if ($tr->{'song'}) {
				if ($var) {
					$alstrx .=  "\t" . ++$snum . ". $tr->{'song'} - $tr->{'artist'}";
					$alstr .=  "<li> $tr->{'song'} - $tr->{'artist'}";
				} else {
					$alstrx .=  "\t\t" . ++$snum . ". $tr->{'song'}";
					$alstr .=  "<li> $tr->{'song'}";
				}
				if ($tr->{'length'}) {
					$alstr .=  " [" . &timemake($tr->{'length'}) . "]";
					$alstrx .=  " [" . &timemake($tr->{'length'}) . "]";
					$allen += $tr->{'length'};
					$arlen += $tr->{'length'};
				}
				$alstr .=  "\n";
				$alstrx .=  "\n";
				$altr++;
				$artr++;
			}
		}
		$yr = $collection{$al}->{'year'} ? "- $collection{$al}->{'year'} " : "";
		if ($var) {
			$arstrx .= qq|$al $yr(T:$altr) [| . &timemake($allen) . qq|]\n$alstrx\n|;
			$arstr .= qq|<a class=bGreenHdrSet href="javascript:showLevel('Album$count','imgAlbum$count');"><img border=0 id=imgAlbum$count src=plusbl.gif><b>$al $yr(T:$altr) [| . &timemake($allen) . qq|]\n</b></a><br><div id=Album$count style='position:relative;left:+15px;display:none'><ol>$alstr</ol></div>\n|;
		} else {
			$arstrx .= qq|\t$al $yr(T:$altr) [| . &timemake($allen) . qq|]\n$alstrx|;
			$arstr .= qq|<a href="javascript:showLevel('Album$count','imgAlbum$count');"><img border=0 id=imgAlbum$count class=subImage src=plusbl.gif></a><a href="javascript:showLevel('Album$count','imgAlbum$count');" class=bGreenHdrAlbum><b>$al $yr(T:$altr) [| . &timemake($allen) . qq|]\n</b></a><br><div id=Album$count style='position:relative;left:+15px;display:none'><ol>$alstr</ol></div>|;
		}
	}
	$count++;
	print "." if ($count % 7 == 0);
	if ($var) {
		$arstr =~ s/:\+15/:\+6/g;
		print OUTHTML &uncode($arstr);
		print OUTTXT &uncode($arstrx);
	} else {
		print OUTTXT &uncode(qq|$art (D:$cd, T:$artr) [| . &timemake($arlen) . qq|]\n$arstrx\n|);
		print OUTHTML &uncode(qq|<a class=bBlueHdrSet href="javascript:showLevel('Set$count','imgSet$count');"><img id=imgSet$count border=0 src=plusbl.gif><b>$art (D:$cd, T:$artr) [| . &timemake($arlen) . qq|]\n</b></a><br><div id=Set$count style='display:none'>$arstr</div>\n|);
	}
}

print OUTHTML "<p><b class=bHdr>Playlists</b><p>\n";
print OUTTXT "PLAYLISTS\n\n";

my ($playliststxt,$playlistshtml);

foreach $play (keys(%playlists)) {
	my $playlen = my $snum = 0;
	my $songstxt = my $songshtml = "";
	foreach $tr (@{$playlists{$play}}) {
		$count++;
		$playlen += $tr->{'length'};
		$songstxt .= "\t" . ++$snum . ". $tr->{'song'} - $tr->{'artist'} [" . &timemake($tr->{'length'}) . "]\n";
		$songshtml .= "<li> $tr->{'song'} - $tr->{'artist'} [" . &timemake($tr->{'length'}) . "]\n";
	}
	$playliststxt .= "$play (T:" . scalar(@{$playlists{$play}}) . ") ["  . &timemake($playlen) . qq|]\n$songstxt\n|;
	$playlistshtml .= qq|<a class=bGreenHdrSet href="javascript:showLevel('Album$count','imgAlbum$count');"><img border=0 id=imgAlbum$count src=plusbl.gif><b>$play (T:| . scalar(@{$playlists{$play}}) . qq|) [| . &timemake($playlen) . qq|]\n</b></a><br><div id=Album$count style='position:relative;left:+15px;display:none'><ol>$songshtml</ol></div>\n|;
  	$playliststxt .= "\n";
}

print OUTHTML &uncode($playlistshtml);
print OUTTXT &uncode($playliststxt);
print OUTHTML << "ENDOUTHTML";
</td></tr></table>
</body></html>
ENDOUTHTML

close(OUTHTML);
close(OUTTXT);
print "\n\nDone!\n";
exit(0);


sub timemake {
	my ($sec) = @_;
	my $ti = sprintf("%02d",int($sec/3600)) . ":";
	$sec = $sec % 3600;
 	$ti .= sprintf("%02d",int($sec/60)) . ":" . sprintf("%02d",$sec % 60);
	return($ti);
}

sub bythe {
	my $c = $a;
	my $d = $b;
	$c =~ s/^The //;
	$d =~ s/^The //;
	my $ret = uc($c) cmp uc($d);
	return($ret) if ($ret);
	return(0);
}

sub byyear {
	my $ret = $collection{$a}->{'year'} <=> $collection{$b}->{'year'};
	return($ret) if ($ret);
	$ret = uc($a) cmp uc($b);
	return($ret) if ($ret);
	return(0);
}

sub bysong {
	my $ret = uc($a->{'song'}) cmp uc($b->{'song'});
	return($ret) if ($ret);
	return(0);
}

sub byart {
	my $ret = $collection{$a}->{'artist'} cmp $collection{$b}->{'artist'};
	return($ret) if ($ret);
	$ret = $a cmp $b;
	return($ret) if ($ret);
	return(0);
}




sub parsomatic {

	my($albartist, $album, $artist, $total, $size, $totlength, $length, $qq, $song, $sort, $stuffptr, $track, %info, $year, $count);
	my @id = %playlist = %collection = ();

	open(FILE,'iTunesDB') or die "Could not open old iTunesDB: $!\n"; 
	binmode(FILE); #for Non-Unix systems..
	

	#check the header
	if(getfoo(0, (length($ipodmagic)+2)/3) ne $ipodmagic)
	{
	die "err: could open the file, but:\nI don't think, thats an ipod - tunes db!\n";
	}

	$qq = 292; #the magic number!! (the HARDCODED start of the first mhit)

# gnutunes header

  while($qq != -1) {
	%info = ();
	($qq,$stuffptr) = get_nod_a($qq); #get_nod_a returns wher it's guessing the next MHIT, if it fails, it returns '-1'

	if (defined(%$stuffptr)) {
		%info = %$stuffptr;
	
		$artist = $info{'artist'};
		$year = (defined($info{'year'})) ? $info{'year'} : "";
		$song = $info{'song'};
		$album = ($info{'album'}) ? $info{'album'} : "No album";
		$track = (defined($info{'track'})) ? $info{'track'} : 0;
		$length = $info{'length'};
		$tr = 0;
		
		$collection{$album}->{'sort'} = ($track) ? "track" : "artist" unless (defined($collection{$album}->{'sort'}));
		$sort = $collection{$album}->{'sort'};
		$tr = ($sort eq "artist") ? @{$collection{$album}->{'tracks'}} : $track;
		${$collection{$album}->{'tracks'}}[$tr]->{"song"} = $song;
		${$collection{$album}->{'tracks'}}[$tr]->{"length"} = $length;
		$collection{$album}->{'artist'} = $artist unless (defined($collection{$album}->{'artist'}));
		$collection{$album}->{'year'} = $year unless (defined($collection{$album}->{'year'}));
		${$collection{$album}->{'tracks'}}[$tr]->{"artist"} = $artist;
		$albartist = $collection{$album}->{'artist'};
		if ($artist ne $albartist) {
			$albartist = $album;
			$collection{$album}->{'artist'} = "$albartist:Various"
		}
		$total++;
		$totlength += $length;
		$size += $info{'size'};
		$id[$info{'id'}]->{'song'} = $song;
		$id[$info{'id'}]->{'artist'} = $artist;
		$id[$info{'id'}]->{'length'} = $length;
		print "." if ($total % 10 == 0);
	}
  }

  $qq = getshoe(112, 4)+292;
  while($qq != -1) {
	($qq, $mpl, $cont, $plname) = get_pl($qq);
	next if ($mpl);
	$count = 0;
	foreach $song (@$cont) {
		$playlist{$plname}->[$count]->{'artist'} = $id[$song]->{'artist'};
		$playlist{$plname}->[$count]->{'song'} = $id[$song]->{'song'};
		$playlist{$plname}->[$count++]->{'length'} = $id[$song]->{'length'};
	}
  }

  print "\n";

  close(FILE);
  return(\%collection,\%playlist,$total, $totlength, $size);
}


sub get_pl
{
my ($sum) = @_;
my($elx, $otxt, $zip, $plname, $oid, $count, $mpl, @ret);
 if(getfoo($sum+20, 1) == 1)
 {
  $mpl=1; #main playlist, we ignore the MPL
 }

$sum = $sum+680+76;

($oid, undef, $plname) = get_mhod($sum);

if($mpl && !$plname) {
 print "\n\nWhoops! Detected 'funny' iTunesDB!\n->'Musicmatch bug' workaround enabled\n";
 $plname="buggy"; #give a fake name and don't seek
}
else {
$sum+=$oid;
}
 while($zip !=-1)
 {
  $sum = $zip+$sum+76;
  ($zip, undef, $otxt) = get_mhod($sum);
  $elx = getshoe($sum-52, 4);                 #ugly hack, get a PL  item
   push(@ret,$elx) if $elx && getfoo($sum, 4) eq "6d 68 6f 64";
   print "." if (++$count % 100 == 0);
 }

if($plname)
{ return (($sum-76), $mpl, \@ret, $plname); }
else { return -1;}
}




sub get_nod_a {
my(@jerk, $sum, $zip, $otxt, $oid);
my %stuff = ();
($sum) = @_;
if(getfoo($sum, 4) eq "6d 68 69 74") #aren't we lost?
{

$stuff{'id'} = getshoe($sum+16 , 4);
$stuff{'size'}  = getshoe($sum+36 , 4);
$stuff{'length'} = int(getshoe($sum+40,4)/1000);
$stuff{'track'} = getshoe($sum+44,4); #song number
$stuff{'year'} = getshoe($sum+52,4); #year

  $sum += 156;                 #1st mhod starts here!
    while($zip != -1) {
     $sum = $zip+$sum; 
     ($zip, $oid, $otxt) = get_mhod($sum);    #returns the number where its guessing the next mhod, -1 if it's failed
      $jerk[$oid] = xmlstring($otxt);
    }

$stuff{'song'} = $jerk[1];
$stuff{'album'} = $jerk[3];
$stuff{'artist'} = $jerk[4];

#foreach $i (keys(%stuff)) {
#	print "$i - $stuff{$i}\n";
#}

#print ".";
return ($sum-$zip-1,\%stuff);          #black magic
}

  else {
  return "-1";
  }


}




sub xmlstring
{
my($ret) = @_;
$ret =~ s/&/&amp;/g;
$ret =~ s/"/&quot;/g;
$ret =~ s/</&lt;/g;
$ret =~ s/>/&gt;/g;
$ret =~ s/'/&apos;/g;
return $ret;
}


sub uncode
{
my($ret) = @_;
$ret =~ s/&amp;/&/g;
$ret =~ s/&quot;/"/g;
$ret =~ s/&apos;/'/g;
return $ret;
}










#get a SINGLE mhod entry:
#
# get_mhod(START_OF_MHOD);
#
# return+seek = new_mhod should be there
sub get_mhod() {
my($seek, $xl, $ml, $mty, $foo, $id);
($seek) = @_;

$id = getfoo($seek, 4);                    #are we lost?

#print OUTHTML "ID: ".getstr($seek, 4)."\n";

$ml = getshoe($seek+8, 4);
$mty = getshoe($seek+12, 4);         #genre number
$xl = getshoe($seek+28,4);           #Entrylength


  if($id ne "6d 68 6f 64") { $ml = -1;} #is the id INcorrect??
 
  else {
  #get the TYPE of the DB-Entry


$foo = getstr($seek+40, $xl); #string of the entry
$foo =~ tr/\0//d; #we have many \0.. killem!

  return ($ml, $mty, $foo);
 }
}






sub getfoo {
#reads $anz chars from FILE and returns HEX values!
my($anz, $buffer, $xx, $xr, $start, $noseek);
($start, $anz, $noseek) = @_;
# paranoia checks
if(!$start) { $start = 0; }
if(!$anz) { $anz = "1"; }

#seek to the given position

seek(FILE, $start, 0);
#start reading
read(FILE, $buffer, $anz);
  foreach(split(//, $buffer)) {
$xx = sprintf("%02x ", ord($_));
$xr = "$xr$xx";
  }
 chop($xr);# no whitespace at end
 
 return $xr;
}





sub getshoe {
#reads $anz chars from FILE and returns int 
my($anz, $buffer, $xx, $xr, $start, $noseek, $xxt);
($start, $anz, $noseek) = @_;
# paranoia checks
if(!$start) { $start = 0; }
if(!$anz) { $anz = "1"; }

#seek to the given position

seek(FILE, $start, 0);
#start reading
read(FILE, $buffer, $anz);
   foreach(split(//, $buffer)) {
    $xx = sprintf("%02X", ord($_));
   $xr = "$xx$xr";
  }
  $xr = oct("0x".$xr);
 return $xr;
}







sub getstr {
#reads $anz chars from FILE and returns a string!
my($anz, $buffer, $xx, $xr, $start, $noseek);
($start, $anz, $noseek) = @_;
# paranoia checks
if(!$start) { $start = 0; }
if(!$anz) { $anz = "1"; }

#seek to the given position
#if 3th ARG isn't defined

seek(FILE, $start, 0);
#start reading
read(FILE, $buffer, $anz);

 return $buffer;
}

